; MP3 Player, Download and Play from DRAM (no hard drive)
;   http://www.pjrc.com/tech/mp3
; Copyright (c) 2000, PJRC.COM, LLC

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

; As a specific exception to the GPL, the executable object code built
; from this source code may be combined with hardware configuration data
; files.  A hardware configuration data file is a set of data that is
; transmitted to an intergrated circuit that is not a general purpose
; microprocessor or microcontroller, in order to establish its normal
; operation.  The process of combining the executable ojbect code built
; from the GPL licensed source code with the hardware configuration data
; shall be considered an aggregation of another work not based on the
; Program.  While the GPL does not restrict use of the program, any
; use restriction associated with the hardware configuration data (for
; example, that it only be used with particular hardware) shall apply
; to the combined file which includes a copy of the hardware configuration
; data.

; Contact: paul@pjrc.com


.equ    location, 0x3000        ;where this program will exist




; registers implemented in the DRAM, IDE, and DMA controller
.equ    dram_page_cfg,  0xFF00
.equ    irq_ident,      0xFF50
.equ    dma_mp3_src,    0xFF28
.equ    dma_mp3_count,  0xFF2A
.equ    dma_mp3_go,     0xFF59
.equ    irq_dma_mp3_ack,0xFF5D

; library functions in bank1 (bank switch special calling)
.equ    call_bank1, 0x0FE0
.equ    xdownload, 0xA040
.equ    sta013_init, 0xA043
.equ    alt_xdownload, 0xA049
.equ    sta013_rd, 0xA04C
.equ    sta013_wr, 0xA04F
.equ	paulmon2, 0x006D




;internal memory usage
.equ	dl_buf, 0x10		;4 bytes
.equ	simm_size, 0x14		;1 byte  (0=4M, 1=8M, 2=16M, 3=32M)
.equ	last_block, 0x15	;2 bytes
  



;*************************************************************
;**                                                         **
;**         Download MP3 file (uuencoded 4k blocks)         **
;**                                                         **
;*************************************************************


.org    location
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'W',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "Download MP3 to DRAM",0
.org    location+64             ;executable code begins here


	acall	init_memory_mgr
	mov	dptr, #msg_begin_dl
	lcall	pstr
	mov	r2, #40			;always start at block 40
	mov	r3, #0
	mov	a, #1
	acall	map_block		;map block 40 (info) to 0x1000
	mov	dptr, #0x1000
	clr	a
	mov	r4, #128
clr_info_loop:
	movx	@dptr, a		;clear first 128 bytes of block 40
	inc	dptr
	djnz	r4, clr_info_loop

wait_line_start:
	mov	r4, #0
wait_line:
	acall	cin
check_e:cjne	r4, #0, check_n
	cjne	a, #'e', check_crlf
	inc	r4
	sjmp	wait_line
check_n:cjne	r4, #1, check_d
	cjne	a, #'n', check_crlf
	inc	r4
	sjmp	wait_line
check_d:cjne	r4, #2, check_crlf
	cjne	a, #'d', check_crlf
	ajmp	finish_dl

check_crlf:
	add	a, #256 - 13			;CR ok between lines
	jz	wait_line_start
	add	a, #(256 - 10 + 13) & 255	;LF ok between lines
	jz	wait_line_start
	add	a, #256 + 10 - 32		;offset to # bytes
	add	a, #256 - 46
	jc	err_dl				;# bytes must be 1 to 45
	add	a, #46
	mov	r1, a				;r1 counts number of bytes
	mov	a, #'.'
	acall	cout
	mov	r0, #dl_buf
	mov	a, dph				;check that dptr is in block
	anl	a, #0xF0
	add	a, #256 - 0x20
	jz	wait_data
	acall	next_block
	mov	a, #2
	acall	map_block			;download into 0x2000 to 0x2FFF
	mov	dptr, #0x2000

wait_data:
	acall	cin
	add	a, #256 - 32
	mov	@r0, a
	inc	r0
	add	a, #256 - 65
	jc	err_dl
	add	a, #32 + 65 - 27
	jz	abort_dl
	cjne	r0, #dl_buf+4, wait_data

extract_1st_byte:
	mov	a, dl_buf+0
	anl	a, #0x3F
	rl	a
	rl	a
	mov	r4, a
	mov	a, dl_buf+1
	anl	a, #0x30
	swap	a
	orl	a, r4
	movx	@dptr, a
	inc	dptr
	dec	r1
	mov	a, r1
	jz	wait_line_start
extract_2nd_byte:
	mov	a, dl_buf+1
	anl	a, #0x0F
	swap	a
	mov	r4, a
	mov	a, dl_buf+2
	anl	a, #0x3C
	rr	a
	rr	a
	orl	a, r4
	movx	@dptr, a
	inc	dptr
	dec	r1
	mov	a, r1
	jnz	extract_3rd_byte
	ajmp	wait_line_start
extract_3rd_byte:
	mov	a, dl_buf+2
	anl	a, #0x03
	rr	a
	rr	a
	mov	r4, a
	mov	a, dl_buf+3
	anl	a, #0x3F
	orl	a, r4
	movx	@dptr, a
	inc	dptr
	dec	r1
	mov	a, r1
	mov	r0, #dl_buf
	jnz	wait_data
	ajmp	wait_line_start


	;abort on any error
err_dl:
	mov	dptr, #mesg_error
	lcall	pstr
	;should have a loop here to swallow up incoming bytes
	;until a brief time with no bytes received.
	ret


	;user pressed esc
abort_dl:
	mov	dptr, #mesg_abort
	lcall	pstr
	ret


	;the download was a success, and it's time to write
	;the last block number
finish_dl:
	mov	dptr, #0x1000
	mov	a, #'M'
	movx	@dptr, a
	inc	dptr
	mov	a, #'P'
	movx	@dptr, a
	inc	dptr
	mov	a, #'3'
	movx	@dptr, a
	inc	dptr
	mov	a, simm_size
	movx	@dptr, a
	inc	dptr
	mov	a, r2
	movx	@dptr, a
	inc	dptr
	mov	a, r3
	movx	@dptr, a
	mov	dptr, #msg_dl_ok
	lcall	pstr
	ret




;*************************************************************
;**                                                         **
;**             Play MP3 File From DRAM Memory              **
;**                                                         **
;*************************************************************


.org    location+0x200
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'S',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "MP3 Play From DRAM",0
.org    location+0x200+64       ;executable code begins here


        mov     dptr, #mesg_sta013_cfg
        lcall   pstr
        mov     dptr, #sta013_init
        lcall   call_bank1
        jnc     sta013_ok
	mov     dptr, #mesg_error
        lcall   pstr
	ljmp	paulmon2
sta013_ok:
        mov     dptr, #mesg_ok
        lcall   pstr


play_from_dram:
	;first, check that block 40 is mapped at 0x1000
	mov	dptr, #dram_page_cfg + 2
	movx	a, @dptr
	cjne	a, #40, err_dram
	inc	dptr
	movx	a, @dptr
	cjne	a, #0, err_dram
	
	;now read the 6 bytes of heading info at 0x1000
	mov	dptr, #0x1000
	movx	a, @dptr
	cjne	a, #'M', err_mp3
	inc	dptr
	movx	a, @dptr
	cjne	a, #'P', err_mp3
	inc	dptr
	movx	a, @dptr
	cjne	a, #'3', err_mp3
	inc	dptr
	movx	a, @dptr
	mov	simm_size, a
	anl	a, #11111100b
	jnz	err_mp3
	inc	dptr
	movx	a, @dptr
	mov	last_block+0, a		;read "last block"
	inc	dptr
	movx	a, @dptr
	mov	last_block+1, a
	mov	r2, #40
	mov	r3, #0
	sjmp	play_mp3_file

err_dram:
	mov	dptr, #msg_err_dram
	acall	pstr
	ret

err_mp3:
	mov	dptr, #msg_err_mp3
	acall	pstr
	ret


play_mp3_file:
	mov	dptr, #msg_play1
	acall	pstr
	mov	a, r3
	acall	phex
	mov	a, r2
	acall	phex
	mov	dptr, #msg_play2
	acall	pstr
	mov	a, last_block+1
	acall	phex
	mov	a, last_block+0
	acall	phex
	acall	newline

play_loop:
	acall	next_block

	mov	a, #2
	acall	map_block		;map 4k block of mp3 file at 0x2000

        mov     dptr, #dma_mp3_src
        clr     a
        movx    @dptr, a                ;write LSB of src addr
        inc     dptr
	mov	a, #0x20
        movx    @dptr, a                ;write MSB of src addr

        mov     dptr, #dma_mp3_count
        mov     a, #0
        movx    @dptr, a                ;write LSB of length
        inc     dptr
        mov     a, #8
        movx    @dptr, a                ;write MSB of length

	mov     dptr, #irq_dma_mp3_ack
        movx    @dptr, a                ;clear any previous interrupt
        mov     dptr, #dma_mp3_go
        movx    @dptr, a                ;begin the transfer
        mov     dptr, #irq_ident
mp3_dma_wait:
	jnb	ri, mp3_dma_wait2
	acall	cin
	cjne	a, #27, mp3_dma_wait2
	ljmp	paulmon2		;abort if they press ESC
mp3_dma_wait2:
        movx    a, @dptr		;now we just wait for it to finish
        jnb     acc.1, mp3_dma_wait

	mov	a, r2
	cjne	a, last_block+0, play_loop
	mov	a, r3
	cjne	a, last_block+1, play_loop

	;finished playing the file... now what?

	ajmp	play_from_dram








;*************************************************************
;**                                                         **
;**                     Memory Manager                      **
;**                                                         **
;*************************************************************





        ;map block number r2/r3 into a page # specified by Acc
map_block:
        anl     a, #15
        rl      a
        add     a, #dram_page_cfg & 255
        mov     dpl, a
        clr     a
        addc    a, #dram_page_cfg >> 8
        mov     dph, a
        mov     a, r2
        movx    @dptr, a
        inc     dptr
        mov     a, r3
        movx    @dptr, a
        ret




        ;initialize the memory manager, figure out what
        ;SIMM is installed, and initialize the memory
        ;block descriptor table.  The first 32 blocks
        ;are always used for the table itself, regardless
        ;of what SIMM is installed.  All the rest are
        ;either free blocks, or not implemented by the SIMM.
        ;The xilinx chip needs to be configured with the
        ;DRAM controller before calling here.
        ;return: C=1 if an error (no SIMM), C=0 for success

init_memory_mgr:
        mov     dptr, #mesg_xilinx_cfg
        lcall   pstr
        mov     dptr, #alt_xdownload
        lcall   call_bank1
        jc      error
        mov     dptr, #mesg_ok
        lcall   pstr

        clr     a
        mov     r2, a
        mov     r3, a
        lcall   map_block
        lcall   write_test_bytes
        lcall   check_test_bytes
        jnc     initmm2
        mov     dptr, #msg_bad_simm
        lcall   pstr
        setb    c
        ret                     ;error, no simm is installed

error:	mov     dptr, #mesg_error
        lcall   pstr
	ljmp	paulmon2

initmm2:
        ;in a smaller 4 or 8 meg simm, writing to block 2048 will
        ;overwrite whatever's in block 0, but 16 and 32 meg simms
        ;have a block 2048, so writing to block 0, then 2048, and
        ;checking to see if block 0 still is correct will tell if
        ;the simm is (4 or 8) vs (16 or 32).
        mov     r2, #2048 & 255
        mov     r3, #2048 >> 8
        clr     a
        lcall   map_block
        lcall   write_test_bytes
        clr     a
        mov     r2, a
        mov     r3, a
        lcall   map_block
        lcall   check_test_bytes
        mov     acc.1, c
        push    acc

        ;double sided simms (8 and 32 megs) implement block 1024
        ;whereas single sided simms can't implement block 1024, so
        ;writing and checking 1024 will tell if it's a single
        ;(4 or 16) or double (8 or 32).
        mov     r2, #1024 & 255
        mov     r3, #1024 >> 8
        clr     a
        lcall   map_block
        lcall   write_test_bytes
        lcall   check_test_bytes
        pop     acc
        mov     acc.0, c
        cpl     a
        anl     a, #3
        mov     simm_size, a    ;store the simm size
        add     a, #2
        movc    a, @a+pc        ;now Acc has simm size, in Mbytes
        sjmp    initmm3
        .db     4, 8, 16, 32
initmm3:
        ;print a message here about which simm we found
        push    acc
        mov     dptr, #msg_found
        lcall   pstr
        pop     acc
        lcall   pint8
        mov     dptr, #msg_size
        lcall   pstr
	ret


        ;write a simple test to a DRAM page, just write
        ;the page number a couple times, with different
        ;XOR'd with different bit patterns.  This way,
        ;we are unlikely to read garbage as good, and
        ;it will always detect a page that is corrupted
        ;by writing to a different page (small simms
        ;which appear repeated 4 times)
write_test_bytes:
        mov     dptr, #dram_page_cfg
        movx    a, @dptr        ;read page # lsb
        mov     b, a
        inc     dptr
        movx    a, @dptr        ;read page # msb
        mov     dptr, #0
        xrl     a, #0x5A
        movx    @dptr, a
        inc     dptr
        cpl     a
        movx    @dptr, a
        inc     dptr
        mov     a, b
        xrl     a, #0x9C
        movx    @dptr, a
        inc     dptr
        cpl     a
        movx    @dptr, a
        ret

        ;read a page previously written with "write_test_bytes"
        ;and return C=0 if good, C=1 if wrong bytes read back
check_test_bytes:
        mov     dptr, #dram_page_cfg
        movx    a, @dptr        ;read page # lsb
        mov     r0, a
        inc     dptr
        movx    a, @dptr        ;read page # msb
        mov     b, a
        mov     dptr, #0
        movx    a, @dptr
        xrl     a, #0x5A
        cjne    a, b, cktb_err
        inc     dptr
        movx    a, @dptr
        xrl     a, #0xA5
        cjne    a, b, cktb_err
        inc     dptr
        mov     b, r0
        movx    a, @dptr
        xrl     a, #0x9C
        cjne    a, b, cktb_err
        inc     dptr
        movx    a, @dptr
        xrl     a, #0x63
        cjne    a, b, cktb_err
        clr     c
        ret
cktb_err:
        setb    c
        ret



	;advance to the next available block... this ought to know
	;about the simm size and avoid going beyond the end, and in
	;the case of a 16 meg simm, move the next implemented range
next_block:
	mov	a, r2
	add	a, #1
	mov	r2, a
	mov	a, r3
	addc	a, #0
	mov	r3, a
	ret


;	mov	a, simm_size
;next_4meg:
;	cjne	a, #0, next_8meg
;next_8meg:
;	cjne	a, #0, next_8meg
;next_16meg:
;	cjne	a, #0, next_8meg
;next_32meg:
;	cjne	a, #0, next_8meg







;*************************************************************
;**                                                         **
;**               Serial Port I/O Functions                 **
;**                                                         **
;*************************************************************


phex:
        acall   phex_b
phex_b: swap    a               ;SWAP A will be twice => A unchanged
phex1:  push    acc
        anl     a, #15
        add     a, #0x90        ; acc is 0x9X, where X is hex digit
        da      a               ; if A to F, C=1 and lower four bits are 0..5
        addc    a, #0x40
        da      a
        acall   cout
        pop     acc
        ret

pstr:   push    acc
pstr1:  clr     a
        movc    a, @a+dptr
        inc     dptr
        jz      pstr2
        mov     c, acc.7
        anl     a, #0x7F
        acall   cout
        jc      pstr2
        sjmp    pstr1
pstr2:  pop     acc
        ret



cin:    jnb     ri, cin
        clr     ri
        mov     a, sbuf
        ret

cout:   jnb     ti, cout
        clr     ti              ;clr ti before the mov to sbuf!
        mov     sbuf, a
        ret

newline:push    acc             ;print one newline
        mov     a, #13
        acall   cout
        mov     a, #10
        acall   cout
        pop     acc
        ret





pint8u: ;prints the unsigned 8 bit value in Acc in base 10
        push    b
        push    acc
        sjmp    pint8b

pint8:  ;prints the signed 8 bit value in Acc in base 10
        push    b
        push    acc
        jnb     acc.7, pint8b
        mov     a, #'-'
        lcall   cout
        pop     acc
        push    acc
        cpl     a
        add     a, #1
pint8b: mov     b, #100
        div     ab
        setb    f0
        jz      pint8c
        clr     f0
        add     a, #'0'
        lcall   cout
pint8c: mov     a, b
        mov     b, #10
        div     ab
        jnb     f0, pint8d
        jz      pint8e
pint8d: add     a, #'0'
        lcall   cout
pint8e: mov     a, b
        add     a, #'0'
        lcall   cout
        pop     acc
        pop     b
        ret





msg_bad_simm:
        .db     "Bad or Missing SIMM",13,10,0
msg_found:
        .db     "Found ",0
msg_size:
        .db     " meg SIMM",13,10,0
mesg_xilinx_cfg:
        .db     "Configuring Xilinx XCS10XL FPGA Chip: ",0
mesg_ok:
        .db     "Ok",13,10,0
mesg_error:
        .db     "Error!",13,10,0
mesg_abort:
        .db     "Abort",13,10,0
msg_dl_ok:
	.db	13,10,"Download completed",13,10,0
msg_begin_dl:
	.db	"Begin sending the MP3 file "
	.db	"(converted with mp3_to_dl):",13,10,0
msg_err_dram:
	.db	"Error, DRAM not initialize from download",13,10,0
msg_err_mp3:
	.db	"Error, Memory doesn't contain a MP3 file",13,10,0
msg_play1:
	.db	"Playing MP3 file from block ",0
msg_play2:
	.db	" to ",0
mesg_sta013_cfg:
        .db     "Configuring STA013 MP3 Decoder Chip: ",0




